Filter builds taxonomy search filter inefficiently
03/31/2020 02:55 PM - Adam Ruzicka

Status: Closed

Priority: Normal

Assignee: Adam Ruzicka

Category: Users, Roles and Permissions

Target version:

Difficulty: Fixed in Releases: 2.1.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p

ull/7553
Description

If a filter supports taxonomy filtering and the role has many taxonomies assigned then the resulting search query could look like

(organization_id = 1 OR organization_id = 2 OR organization_id = 3) AND (location_id = 1 or locati
on_id = 2)

However scoped search support using the IN operator, so we could get a more compact query, something along the lines of

organization_id ~ (1,2,3) AND location_id »~ (1,2)

Related issues:

Related to foreman-tasks - Bug #30797: Postgres usage spikes and disk space c... Rejected
Related to Foreman - Bug #30847: Filters needs to rebuild the taxonomy_search Closed
Blocked by Foreman - Refactor #29532: Update scoped_search to 4.1.8 Closed

Associated revisions

Revision 72209166 - 04/16/2020 11:52 AM - Adam Ruzicka

Fixes #29447 - Build more efficient taxonomy search for filters
If a filter supported taxonomy filtering and the role had many taxonomies
assigned then the resulting search query consisted of many id comparisons joined

together with ORs. This commit generates more efficient query by performing the
search asid IN (...).

History

#1 - 03/31/2020 03:04 PM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/7553 added

#2 - 04/15/2020 10:37 AM - Anonymous
- Blocked by Refactor #29532: Update scoped_search to 4.1.8 added

#3 - 04/16/2020 11:52 AM - The Foreman Bot
- Fixed in Releases 2.1.0 added

#4 - 04/16/2020 11:52 AM - Tomer Brisker

- Category set to Users, Roles and Permissions

#5 - 04/16/2020 12:01 PM - Adam Ruzicka
- Status changed from Ready For Testing to Closed
Applied in changeset 72209166fa58d3c5bc2b3629d98696edf7bd7250.

#6 - 09/10/2020 03:56 PM - Ondrej Ezr
- Related to Bug #30797: Postgres usage spikes and disk space completely filled up, when non-admin select Monitor -> Tasks added

#7 - 09/15/2020 11:56 AM - Ondfej Ezr
- Related to Bug #30847: Filters needs to rebuild the taxonomy_search added
